package org.zeroturnaround.javarebel.integration;

import java.beans.Introspector;

import org.zeroturnaround.javarebel.ClassEventListener;

public class IntegrationClassEventListener implements ClassEventListener {
  public void onClassEvent(int eventType, Class klass) {
    if (eventType == ClassEventListener.EVENT_LOADED)
      return;

    //Flush JavaBeans reflection cache
    Introspector.flushFromCaches(klass);

    //Reset Groovy callsite caching
    try {
      klass.getDeclaredField("$callSiteArray").set(null, null);
    } catch (NoSuchFieldException e) {
    } catch (IllegalAccessException e) {
    }
  }
  
  public int priority() {
    return PRIORITY_CORE + 100000;
  }
}
