package org.zeroturnaround.javarebel.integration.resin;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>com.caucho.server.resin.Resin</code>.
 * 
 * @author Rein Raudjärv
 */
public class ResinCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("org.zeroturnaround.javarebel.integration.resin");
    
    /*
     * Since Resin 3.1 check that the JavaRebel Resin patch is applied correctly. 
     */
    if (isResin31AtLeast(ctClass)) {
      ctClass.getDeclaredMethod("initMain").insertBefore("ResinPatchHelper.checkEnabled();");
    }
  }
  
  private static boolean isResin31AtLeast(CtClass ctClass) throws NotFoundException {
    CtClass[] interfaces = ctClass.getInterfaces();
    for (int i = 0; i < interfaces.length; i++)
      if ("com.caucho.loader.EnvironmentBean".equals(interfaces[i].getName()))
        return true;
    return false;
  }
  
}
